// GLtutor1View.cpp : implementation of the CGLtutor1View class
//

#include "stdafx.h"
#include "GLtutor1.h"

#include "GLtutor1Doc.h"
#include "GLtutor1View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor1View

IMPLEMENT_DYNCREATE(CGLtutor1View, CView)

BEGIN_MESSAGE_MAP(CGLtutor1View, CView)
	//{{AFX_MSG_MAP(CGLtutor1View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor1View construction/destruction

CGLtutor1View::CGLtutor1View()
{
	// TODO: add construction code here
	my_GLRendContext = NULL;
	my_GLpixelindex=0;
}

CGLtutor1View::~CGLtutor1View()
{
}

BOOL CGLtutor1View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	//Om openGL compatibel-window te hebben, moet het venster 'clipable' 
	//zijn. Dus dit volgende ene lijntje past de stijl van de window-structuur
	//aan.
 	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor1View drawing

void CGLtutor1View::OnDraw(CDC* pDC)
{
	CGLtutor1Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor1View diagnostics

#ifdef _DEBUG
void CGLtutor1View::AssertValid() const
{
	CView::AssertValid();
}

void CGLtutor1View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGLtutor1Doc* CGLtutor1View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGLtutor1Doc)));
	return (CGLtutor1Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor1View message handlers

/*Hierna volgen 2 eigen toegevoegde functies die worden aangeroepen in de
OnCreate-functie van de View class.
Deze zetten de PixelFormat voor de GLrenderer compatible met de clientDC (area waar
op getekend zal worden.)
Daarna wordt een rendering context op de ClientDC gemaakt zodat de OpenGL renderer
hierop tekent.
Als dit alles klaar is, dan ben je klaar om te grafische objecten weer te geven.
*/

CGLtutor1View::SetWindowPixelFormat(HDC myDC)
{
	//Hier zeggen we in 'pixelDesc' wat we graag zouden hebben
	//(dus in hoeveel kleuren we willen renderen, of we dit direct in een
	//  bitmap kunnen renderen etc etc)
	//daarna checken we of wat we willen ook aanwezig is (choosepixelformat)
	//Deze functie geeft een array weer van verschillende mogelijkheden
	//die min of meer (of helemaal) weerspiegelen wat we hebben.
	//bvb.
	//wij willen een 32bit kleuren renderer met een 32bit dieptebuffer.
	//maar als onze desktop momenteel in 16bit kleuren staat, dan moet
	//er een aanpassing gedaan worden. Dus een van de terugkerende array
	//zal dus een 16bit versie zijn van de renderer die wij eigenlijk willen 
	//hebben.
	//Sommige kaarten hebben geen 32bit z-buffer (depth) ondersteuning.
	//Voor meer info, bekijk de commentaar eens in de MSDN onder
	//pixelformatdescriptor.
	//
	//Daarna kiezen we een van de 'pixelformats' die bruikbaar zijn op de huidige
	//PC en vragen we om de omschrijving in onze 'pixelDesc' te zetten.
	//Op het laatste zetten we de pixelformat zodat de OpenGL renderer van deze info
	//kan gebruik maken als hij naar het scherm wilt schrijven.

	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize		= sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion	= 1;
	pixelDesc.dwFlags	=	PFD_DRAW_TO_WINDOW | 
							PFD_DRAW_TO_BITMAP | 
							PFD_SUPPORT_OPENGL | 
							PFD_SUPPORT_GDI | 
							PFD_STEREO_DONTCARE;

	pixelDesc.iPixelType		= PFD_TYPE_RGBA;
	pixelDesc.cColorBits		= 32;
	pixelDesc.cRedBits			= 8;
	pixelDesc.cRedShift			= 16;
	pixelDesc.cGreenBits		= 8;
	pixelDesc.cGreenShift		= 8;
	pixelDesc.cBlueBits			= 8;
	pixelDesc.cBlueShift		= 0;
	pixelDesc.cAlphaBits		= 0;
	pixelDesc.cAlphaShift		= 0;
	pixelDesc.cAccumBits		= 64;	
	pixelDesc.cAccumRedBits		= 16;
	pixelDesc.cAccumGreenBits	= 16;
	pixelDesc.cAccumBlueBits	= 16;
	pixelDesc.cAccumAlphaBits	= 0;
	pixelDesc.cDepthBits		= 32;
	pixelDesc.cStencilBits		= 8;
	pixelDesc.cAuxBuffers		= 0;
	pixelDesc.iLayerType		= PFD_MAIN_PLANE;
	pixelDesc.bReserved			= 0;
	pixelDesc.dwLayerMask		= 0;
	pixelDesc.dwVisibleMask		= 0;
	pixelDesc.dwDamageMask		= 0;

	//variable my_GLpixelindex kan gevonden worden in de class
	//GLtutor1View in "GLtutor1View.h" en moet daar geplaatst worden,
	//zodat de member-functies er gebruik van kunnen maken.
	my_GLpixelindex = ChoosePixelFormat(myDC, 
										&pixelDesc);
	if (my_GLpixelindex==0)
	{
		my_GLpixelindex = 1;	// Let's choose a default index.
		if (DescribePixelFormat( myDC, 
								 my_GLpixelindex, 
								 sizeof(PIXELFORMATDESCRIPTOR), 
								 &pixelDesc)==0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	myDC, 
						my_GLpixelindex, 
						&pixelDesc)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;

}

CGLtutor1View::CreateGLRenderContext(HDC myDC)
{
	/*Hier zeggen we dat de output van OpenGL moet getoond worden in de
	client area van onze window (de Device Context van ons venster).
	"OpenGL Render Contect (RC)" is eigenlijk hetzelfde als de "Device Context" voor
	windows. De RC wordt enkel specifiek gebruikt voor OpenGL uitvoer. En DC voor
	windows uitvoer.

	Het leuke is dat OpenGL meerdere contexten kan hebben.
	bvb in Render-context 1 hebben we een voetbal gerenderd en in Render-context 2
	een kubus. Nu kunnen we de twee contexten afwisselen door de functie 'MakeCurrent'
	te gebruiken.
	Met MakeCurrent kun je kiezen welke 'render-context' op uw windowke (client-area)
	moet geplaatst worden.
	Je kan dit bvb ook toepassing als je meerdere monitors aan je computer aangesloten
	hebt. Met op de ene monitor een 'wireframe' object en op de andere het gerenderde
	object.
	*/

	//my_hGLRendContext variable kan gevonden worden in de class
	//GLtutor1View in "GLtutor1View.h" zodat alle member-functies hiervan gebruik
	//kunnen maken.

	my_GLRendContext = wglCreateContext(myDC); //functie aanroepen. RenderContext moet
												//compatible zijn met de ClientDC (=myDC ;
												//wordt doorgegeven via OnCreate member-
												//functie.)
	if (my_GLRendContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	//Om het simpel te houden, maken we de zojuist gemaakte RenderContext de huidige
	//context, zodat alles wat we aan OpenGL doorgeven op de clientDC-area getoond worden.
	if (wglMakeCurrent(myDC, my_GLRendContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}

int CGLtutor1View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here:

	//Handle naar onze volledig window
	HWND hWnd = GetSafeHwnd();

	//handle naar de client-area (gebied waar getekend zal worden)
	HDC hDC = ::GetDC(hWnd);

	//zorg dat OpenGL output compatible is met ons windowke.
	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;

	//zorg dat de OpenGL uitvoer op ons windowke komt.
	if (CreateGLRenderContext(hDC)==FALSE)
		return 0;
		
	return 0;
}

void CGLtutor1View::OnDestroy() 
{

	if(wglGetCurrentContext()!=NULL) 
	{
		// Zorg dat er geen verwijzing is tussen de OpenGL renderer en ons windowke.
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (my_GLRendContext!=NULL)
	{
		//verwijder onze OpenGL Rendering Context.
		wglDeleteContext(my_GLRendContext);
		my_GLRendContext = NULL;
	}

	//Nu kan de gewone window verwijderd worden.
	CView::OnDestroy();	
	
}
