// GLtutor2View.cpp : implementation of the CGLtutor2View class
//

#include "stdafx.h"
#include "GLtutor2.h"

#include "GLtutor2Doc.h"
#include "GLtutor2View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor2View

IMPLEMENT_DYNCREATE(CGLtutor2View, CView)

BEGIN_MESSAGE_MAP(CGLtutor2View, CView)
	//{{AFX_MSG_MAP(CGLtutor2View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor2View construction/destruction

CGLtutor2View::CGLtutor2View()
{
	// TODO: add construction code here
	my_GLRendContext = NULL;
	my_GLpixelindex=0;

}

CGLtutor2View::~CGLtutor2View()
{
}

BOOL CGLtutor2View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor2View drawing

void CGLtutor2View::OnDraw(CDC* pDC)
{
	CGLtutor2Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor2View diagnostics

#ifdef _DEBUG
void CGLtutor2View::AssertValid() const
{
	CView::AssertValid();
}

void CGLtutor2View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGLtutor2Doc* CGLtutor2View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGLtutor2Doc)));
	return (CGLtutor2Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor2View message handlers
CGLtutor2View::SetWindowPixelFormat(HDC myDC)
{
	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize		= sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion	= 1;
	pixelDesc.dwFlags	=	PFD_DRAW_TO_WINDOW | 
							PFD_GENERIC_ACCELERATED | 
							PFD_SUPPORT_OPENGL |
							PFD_SUPPORT_GDI;

	pixelDesc.iPixelType		= PFD_TYPE_RGBA;
	pixelDesc.cColorBits		= 32;
	pixelDesc.cRedBits			= 8;
	pixelDesc.cRedShift			= 16;
	pixelDesc.cGreenBits		= 8;
	pixelDesc.cGreenShift		= 8;
	pixelDesc.cBlueBits			= 8;
	pixelDesc.cBlueShift		= 0;
	pixelDesc.cAlphaBits		= 0;
	pixelDesc.cAlphaShift		= 0;
	pixelDesc.cAccumBits		= 64;	
	pixelDesc.cAccumRedBits		= 16;
	pixelDesc.cAccumGreenBits	= 16;
	pixelDesc.cAccumBlueBits	= 16;
	pixelDesc.cAccumAlphaBits	= 0;
	pixelDesc.cDepthBits		= 32;
	pixelDesc.cStencilBits		= 8;
	pixelDesc.cAuxBuffers		= 0;
	pixelDesc.iLayerType		= PFD_MAIN_PLANE;
	pixelDesc.bReserved			= 0;
	pixelDesc.dwLayerMask		= 0;
	pixelDesc.dwVisibleMask		= 0;
	pixelDesc.dwDamageMask		= 0;

	my_GLpixelindex = ChoosePixelFormat(myDC, 
										&pixelDesc);
	if (my_GLpixelindex==0)
	{
		my_GLpixelindex = 1;	// Let's choose a default index.
		if (DescribePixelFormat( myDC, 
								 my_GLpixelindex, 
								 sizeof(PIXELFORMATDESCRIPTOR), 
								 &pixelDesc)==0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	myDC, 
						my_GLpixelindex, 
						&pixelDesc)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;

}

CGLtutor2View::CreateGLRenderContext(HDC myDC)
{
	my_GLRendContext = wglCreateContext(myDC); 

	if (my_GLRendContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	if (wglMakeCurrent(myDC, my_GLRendContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}


int CGLtutor2View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here

	//Handle naar onze volledig window
	HWND hWnd = GetSafeHwnd();

	//handle naar de client-area (gebied waar getekend zal worden)
	HDC hDC = ::GetDC(hWnd);

	//zorg dat OpenGL output compatible is met ons windowke.
	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;

	//zorg dat de OpenGL uitvoer op ons windowke komt.
	if (CreateGLRenderContext(hDC)==FALSE)
		return 0;
		
	
	return 0;
}

void CGLtutor2View::OnDestroy() 
{

	if(wglGetCurrentContext()!=NULL) 
	{
		// Zorg dat er geen verwijzing is tussen de OpenGL renderer en ons windowke.
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (my_GLRendContext!=NULL)
	{
		//verwijder onze OpenGL Rendering Context.
		wglDeleteContext(my_GLRendContext);
		my_GLRendContext = NULL;
	}

	//Nu kan de gewone window verwijderd worden.
	CView::OnDestroy();	
}

void CGLtutor2View::OnSize(UINT nType, int cx, int cy) 
{
	//verander eerst ons window-grootte door een windows-functie
	//op te roepen
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	
	// OpenGL heeft zijn eigen types van variabelen.
	GLsizei width, height;
//	GLdouble aspect;

	width = cx;
	height = cy;

	/* We willen dat OpenGL op de volledige grootte van ons window tekent,
	dus zetten we de viewport op dezelfde grootte als onze window. 
	Men kan dus ook bvb een klein deel ervan gebruiken en de rest om text-
	output te geven of via GDI een bitmap te laten tonen.
	*/
	glViewport(0, 0, width, height);

     
	/* Er zijn 3 matrices die OpenGL bijhoudt. 1 om de hele 'scene' te 
	projecteren op het scherm (GL_PROJECTION), GL_MODELVIEW wordt gebruikt om
	objecten (TRIANGLES, CUBES, etc etc) te projecteren in de 'scene'. En ten
	laatste GL_TEXTURE om texturen te projecteren op objecten. */
	glMatrixMode(GL_PROJECTION);
	
	/* We laden we de projectie-matrix met een eenheidsmatrix. Dus we gaan de 
	'scene' (de "wereld" van onze objecten) niet transformeren in iets bepaald.
	(geen rotaties, verschuivingen etc... Zie wiskunde Mr.Bogo van 2de jaar )
	Maw. deze matrix stelt onze "camera" in die naar de 3D wereld kijkt. We 
	kunnen door een andere matrix in te stellen, zorgen dat onze camera bvb 
	schuin op die wereld kijkt.*/
	glLoadIdentity();

	/* gluOrtho2D(left, right, bottom, top);
	Deze geven de wereldcordinaten weer waarin getekend wordt.
	Deze wereldcordinaten worden dan herschaald, voordat getekend wordt naar 
	uw window. 
	Bvb. als uw window 200x200 is en u stelt uw wereldcordinaten in op
	500x500, dan zal punt (75,25) in de render-wereld getekend worden op
	punt (30, 10) op uw client-window. (ratio 2/5)
	
	Als men (0,500,0,500) zou nemen, dan komt cordinaat (0,0) overeen met
	links-beneden. Nu is punt (0,0) links boven. 
	Experimenteer zelf maar...*/
	gluOrtho2D(0.0, 500.0, 500.0, 0.0);

	/* Nu laden we de model-matrix ook met de eenheidsmatrix, zodat geen
	transformaties worden uitgevoerd op onze objecten.
	We laten OpenGL in deze matrix-mode, zodat eventuele rotaties op het object
	worden uitgevoerd, en niet op de hele 'render-scene' */
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

void CGLtutor2View::OnPaint() 
{
	/* We gaan hier simpel beginnen.
	OpenGL is gemaakt om snel en krachtig 3D objecten weer te geven. Maar om
	te starten zullen we een simpel 2D object tekenen : een driehoek. */
	
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	
	/* Met glClear kan men de teken-buffer wissen. Men kan ook de
	diepte-buffer wissen alsook andere buffers. Zie de online help.*/
    glClear(GL_COLOR_BUFFER_BIT); // wist het scherm.
	
	/* Dit commando zorgt ervoor dat het resulterende vlak, verschillende
	kleuren bevat. De kleuren van de 3 punten worden geinterpoleerd, wat 
	een mooi effect geeft. Dit kan weggelaten worden, want dit is default.
	Men kan ook GL_FLAT gebruiken, wat dan de kleur van het eerste punt
	gebruikt voor het hele vlak. */
	glShadeModel(GL_SMOOTH);

	/* voordat men het object begint samen te stellen, kan men aan OpenGL 
	zeggen dat hij alle cordinaten roteert over grad graden met de aan-
	gegeven vector. (zie weer wiskunde 2de jaar voor meer uitleg over 
	rotaties en vectors).
	glRotated(grad, x,y,z) 
	In het volgende vb kun je het object laten roteren over 30 graden via
	z-eenheidsvector)*/
//	glRotated(30.0, 0, 0, 1);

	/* glBegin geeft aan dat OpenGL zich klaarmaakt om gegevens te krijgen
	voor het te tekenen object. In dit geval is het een polygoon. Maar ik
	kon evengoed GL_TRIANGLES gebruikt hebben, omdat we toch een driehoek
	gaan tekenen. */
	glBegin(GL_POLYGON);
		/* glColor4f geeft aan dat het volgende punt een bepaalde kleur
		moet hebben. We gebruiken 4 floats om dit te doen.
		Red, Green, Blue, Alpha.. Alpha gebruiken we hier nog niet.
		Je kan dit evengoed vervangen door "glColor3f(r,g,b)"*/
		glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
		/* Volgend commando geeft 1 punt op met 2 wereldcordinaten */
        glVertex2f(110.0f, 350.0f);
		/* volgende 2 punten ook met hun eigen kleur */
		glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
        glVertex2f(4.0f, 1.0f);
		glColor4f(0.0f, 0.6f, 1.0f, 1.0f);
        glVertex2f(450.0f, 50.0f);
	/* glEnd geeft aan dat we gedaan hebben met informatie naar de OpenGL-
	engine te sturen. Het laatste punt ingegeven wordt met het eerste punt
	verbonden. */
	glEnd();

	/* Nu willen we dat OpenGL onze commando's uitvoert. Dus flushen we de
	gegevens-buffer naar de OGL-engine. Deze tekent dan de driehoek op het
	scherm. Hij interpoleert automatisch de verschillende kleuren zodat ze
	in elkaar overgaan.*/
    glFlush();

	// Do not call CView::OnPaint() for painting messages
}
