// GLtutor3Doc.cpp : implementation of the CGLtutor3Doc class
//

#include "stdafx.h"
#include "GLtutor3.h"

#include "GLtutor3Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3Doc

IMPLEMENT_DYNCREATE(CGLtutor3Doc, CDocument)

BEGIN_MESSAGE_MAP(CGLtutor3Doc, CDocument)
	//{{AFX_MSG_MAP(CGLtutor3Doc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3Doc construction/destruction

CGLtutor3Doc::CGLtutor3Doc()
{
	// TODO: add one-time construction code here

	/* Hier gaan we wat variabelen bijplaatsen die we
	doorheen het programma zullen gebruiken in deze
	'document' class. */

	// de y offset van de arm
	arm_OffY = 100;
	// de x offset van de arm
	arm_OffX = 100;
	// Hoek van het eerste stuk vd arm
	arm_angle1 = 15;	
	// de hoek van het 2de stuk van de arm tov
	// het eerste stuk
	arm_angle2 = 15;
}

CGLtutor3Doc::~CGLtutor3Doc()
{
}

BOOL CGLtutor3Doc::OnNewDocument()
{
	/* Deze routine wordt 1 maal opgeroepen aan het begin
	   van uw programma, dus hier kunt u algemene zaken 
	   inzetten zoals een structuur van een polygoon.*/

	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)
	
	/* Een nieuw commando dat we hier gebruiken is
	   glNewList. Dit zorgt ervoor dat we een naam 
	   kunnen geven aan een object. (of groep van objecten)
	   En dit object is opgebouwd uit OGL-commando's.
	   Als we nu willen dat OGL dit object tekent, hoeven
	   we enkel "glCallList" op te roepen met de naam van het
	   object (hier een rechthoek).
	   Dit is een zeer krachtig commando...
	   Een vb:
	     je kan een object "huis" genaamd laten samenstellen
		 uit verschillende polygonen (vierkant voor huis, driehoek
		 voor dak, rechthoek voor schouw etc..). Als je dan op
		 je scherm een paar huizen wilt zetten in verschillende
		 kleuren, kan je een paar maal na elkaar "glCallList(huis)"
		 oproepen ipv elke keer opnieuw een heel huis te gaan 
		 tekenen :
		 glNewList(Huis, GL_COMPILE);
			glBegin(GL_POLYGON);
				{vertexen voor vierkant van huis}
			glEnd();
			glBegin(GL_TRIANGLES)
				{vertexen voor driehoek van dak}
			glEnd();
			glBegin(GL_POLYGON);
				{vertexen voor schouw}
			glEnd();
		 glEndList();

		GL_COMPILE geeft aan dat de opdrachten alleen gecompileerd
		moeten worden door de OGL engine (in hardware of software).
		Als u dat wenst, kan u ineens GL_COMPILE_AND_EXECUTE zetten
		en dan wordt het huis ook al getekend.
	*/
	glNewList(ArmPart, GL_COMPILE);
		glBegin(GL_POLYGON);
			glVertex2f(-10.0f,  10.0f);
			glVertex2f(-10.0f, -10.0f);
			glVertex2f(100.0f, -10.0f);
			glVertex2f(100.0f,  10.0f);
		glEnd();
	glEndList();

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CGLtutor3Doc serialization

void CGLtutor3Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3Doc diagnostics

#ifdef _DEBUG
void CGLtutor3Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGLtutor3Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3Doc commands

void CGLtutor3Doc::RenderScene()
{
	//scherm clearen (zwart - default)
	glClear(GL_COLOR_BUFFER_BIT);

	/* hier zetten we onze default matrix op de stack, want we
	   gaan transformaties uitvoeren. Als we deze uitgevoerd 
	   hebben, willen we wel terug onze originele object-projectie
	   matrix.
	   Als we dit niet op de stack zetten, dan gaan we bij elke
	   aanroep van RenderScene het nulpunt verder verwijderen, 
	   waardoor onze robotarm vlug van het scherm verdwijnt.
	*/
	glPushMatrix();
	/* de rode arm staat normaal op punt (0,0), maar we willen
	   deze met de muis kunnen bewegen, dus wordt (0,0) voor de
	   rode arm (arm_OffX, arm_OffY) op het scherm. 
	   maw. we verschuiven het cordinatenstelsel met 100 over de
	   X-as en ook over de Y-as.
	*/
		glTranslated( arm_OffX, arm_OffY, 0);
		/* we roteren de arm over 'angle1' graden met de z-vector
		   (zie wiskunde 2de jaar)
		*/
		glRotated( arm_angle1, 0, 0, 1);
		/* Hier pushen we de objectmatrix weer.
		   DIT HOEFT NIET, maar ik wou nog maar eens duidelijk
		   het gebruik van dit commando laten zien.
		   U kan nu bvb de kleur instellen en het eerste deel
		   van de arm tekenen. En dan pas de transformatie uitvoeren
		   voor het 2de deel van de arm en dan het tweede deel 
		   tekenen.
		   Maar we slaan hier de matrix op de stack omdat we bij
		   wijze van voorbeeld nu ineens een andere transformatie
		   willen uitvoeren, voordat we het eerste object getekend
		   hebben. Nadat we het 2de object getekend hebben, halen we
		   de matrix terug op en gaan we gewoon verder met het
		   tekenen van het eerste object.
		*/
		glPushMatrix();
			// We schuiven het tweede deel 90 x-cord. verder
			// over het eerste deel. Hierdoor komt een stuk overeen
			// met het rode stuk arm. Verander gerust de waarde
			// 90 eens in 45 of 150 en u zult zien wat ik bedoel.
			glTranslated( 90, 0, 0);
			glRotated( arm_angle2, 0, 0, 1);
			glColor4f(0.0f, 1.0f, 0.0f, 1.0f);
			// hier tekenen we de groene rechthoek door de calllist
			// op te roepen.
			glCallList(ArmPart);
		glPopMatrix();
		// hier tekenen we de rode rechthoek.
		glColor4f(1.0f, 0.0f, 0.0f, 1.0f);
		glCallList(ArmPart);
	// altijd Pop en Push laten uitkomen.
	glPopMatrix();

	//OpenGL pipelines flushen.
	glFlush();

}
