// GLtutor3View.cpp : implementation of the CGLtutor3View class
//

#include "stdafx.h"
#include "GLtutor3.h"

#include "GLtutor3Doc.h"
#include "GLtutor3View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3View

IMPLEMENT_DYNCREATE(CGLtutor3View, CView)

BEGIN_MESSAGE_MAP(CGLtutor3View, CView)
	//{{AFX_MSG_MAP(CGLtutor3View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_SIZE()
	ON_WM_PAINT()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3View construction/destruction

CGLtutor3View::CGLtutor3View()
{
	// TODO: add construction code here
	my_GLRendContext = NULL;
	my_GLpixelindex=0;
	Ldown=FALSE;
	Rdown=FALSE;
}

CGLtutor3View::~CGLtutor3View()
{
}

BOOL CGLtutor3View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3View drawing

void CGLtutor3View::OnDraw(CDC* pDC)
{
	CGLtutor3Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3View diagnostics

#ifdef _DEBUG
void CGLtutor3View::AssertValid() const
{
	CView::AssertValid();
}

void CGLtutor3View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGLtutor3Doc* CGLtutor3View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGLtutor3Doc)));
	return (CGLtutor3Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor3View message handlers

CGLtutor3View::SetWindowPixelFormat(HDC myDC)
{
	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize		= sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion	= 1;
	pixelDesc.dwFlags	=	PFD_DRAW_TO_WINDOW | 
//							PFD_DOUBLEBUFFER |
							PFD_SUPPORT_GDI |
							PFD_GENERIC_ACCELERATED | 
							PFD_SUPPORT_OPENGL;

	pixelDesc.iPixelType		= PFD_TYPE_RGBA;
	pixelDesc.cColorBits		= 32;
	pixelDesc.cRedBits			= 8;
	pixelDesc.cRedShift			= 16;
	pixelDesc.cGreenBits		= 8;
	pixelDesc.cGreenShift		= 8;
	pixelDesc.cBlueBits			= 8;
	pixelDesc.cBlueShift		= 0;
	pixelDesc.cAlphaBits		= 0;
	pixelDesc.cAlphaShift		= 0;
	pixelDesc.cAccumBits		= 64;	
	pixelDesc.cAccumRedBits		= 16;
	pixelDesc.cAccumGreenBits	= 16;
	pixelDesc.cAccumBlueBits	= 16;
	pixelDesc.cAccumAlphaBits	= 0;
	pixelDesc.cDepthBits		= 32;
	pixelDesc.cStencilBits		= 8;
	pixelDesc.cAuxBuffers		= 0;
	pixelDesc.iLayerType		= PFD_MAIN_PLANE;
	pixelDesc.bReserved			= 0;
	pixelDesc.dwLayerMask		= 0;
	pixelDesc.dwVisibleMask		= 0;
	pixelDesc.dwDamageMask		= 0;

	my_GLpixelindex = ChoosePixelFormat(myDC, 
										&pixelDesc);
	if (my_GLpixelindex==0)
	{
		my_GLpixelindex = 1;	// Let's choose a default index.
		if (DescribePixelFormat( myDC, 
								 my_GLpixelindex, 
								 sizeof(PIXELFORMATDESCRIPTOR), 
								 &pixelDesc)==0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	myDC, 
						my_GLpixelindex, 
						&pixelDesc)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;

}

CGLtutor3View::CreateGLRenderContext(HDC myDC)
{
	my_GLRendContext = wglCreateContext(myDC); 

	if (my_GLRendContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	if (wglMakeCurrent(myDC, my_GLRendContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}

int CGLtutor3View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//Handle naar onze volledig window
	HWND hWnd = GetSafeHwnd();

	//handle naar de client-area (gebied waar getekend zal worden)
	HDC hDC = ::GetDC(hWnd);

	//zorg dat OpenGL output compatible is met ons windowke.
	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;

	//zorg dat de OpenGL uitvoer op ons windowke komt.
	if (CreateGLRenderContext(hDC)==FALSE)
		return 0;
	
	return 0;
}

void CGLtutor3View::OnDestroy() 
{
	if(wglGetCurrentContext()!=NULL) 
	{
		// Zorg dat er geen verwijzing is tussen de OpenGL renderer en ons windowke.
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (my_GLRendContext!=NULL)
	{
		//verwijder onze OpenGL Rendering Context.
		wglDeleteContext(my_GLRendContext);
		my_GLRendContext = NULL;
	}

	//Nu kan de gewone window verwijderd worden.
	CView::OnDestroy();	
}

void CGLtutor3View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	GLsizei width, height;

	width = cx;
	height = cy;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluOrtho2D(0.0, 500.0, 500.0, 0.0);
	glMatrixMode(GL_MODELVIEW);

//	glDrawBuffer(GL_BACK);
}

void CGLtutor3View::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CGLtutor3Doc* pDoc = GetDocument();
	pDoc->RenderScene();
	
/*	if (SwapBuffers(dc.m_ps.hdc)==FALSE)
	{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("SwapBuffers returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return;
	}*/
	// Do not call CView::OnPaint() for painting messages
}

void CGLtutor3View::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	Ldown=FALSE;
	CView::OnLButtonUp(nFlags, point);
}

void CGLtutor3View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	Ldown=TRUE;
	LBpos=point;
	CView::OnLButtonDown(nFlags, point);
}

void CGLtutor3View::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	Rdown=TRUE;	
	RBpos=point;
	CView::OnRButtonDown(nFlags, point);
}

void CGLtutor3View::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	Rdown=FALSE;
	CView::OnRButtonUp(nFlags, point);
}

void CGLtutor3View::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (Rdown)
	{
		CGLtutor3Doc* pDoc = GetDocument();
		CSize rotate = RBpos - point;
		RBpos = point;

		pDoc->arm_angle1 -= rotate.cx;
		pDoc->arm_angle2 -= rotate.cy;
		//zorg dat RenderScene via OnPaint wordt aangeroepen.
		InvalidateRect(NULL, FALSE);
	}

	if (Ldown)
	{
		CGLtutor3Doc* pDoc = GetDocument();
		CSize translate = LBpos - point;
		LBpos = point;

		pDoc->arm_OffX -= translate.cx;
		pDoc->arm_OffY -= translate.cy;
		//zorg dat RenderScene via OnPaint wordt aangeroepen.
		InvalidateRect(NULL, FALSE);
	}
	
	CView::OnMouseMove(nFlags, point);
}
