// GLtutor4Doc.cpp : implementation of the CGLtutor4Doc class
//

#include "stdafx.h"
#include "GLtutor4.h"

#include "GLtutor4Doc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4Doc

IMPLEMENT_DYNCREATE(CGLtutor4Doc, CDocument)

BEGIN_MESSAGE_MAP(CGLtutor4Doc, CDocument)
	//{{AFX_MSG_MAP(CGLtutor4Doc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4Doc construction/destruction

CGLtutor4Doc::CGLtutor4Doc()
{
	// TODO: add one-time construction code here
	rotx=0;
	roty=0;
}

CGLtutor4Doc::~CGLtutor4Doc()
{
}

BOOL CGLtutor4Doc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CGLtutor4Doc serialization

void CGLtutor4Doc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4Doc diagnostics

#ifdef _DEBUG
void CGLtutor4Doc::AssertValid() const
{
	CDocument::AssertValid();
}

void CGLtutor4Doc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4Doc commands

void CGLtutor4Doc::RenderScene()
{
	/* deze float-arrays worden op voorhand gedefinieerd zodat
	we ze niet steeds als getallen moeten invoeren, maar direct
	als naam kunnen refereren. */
	GLfloat LightAmbient[] =  { 0.1f, 0.1f, 0.1f, 0.1f};
	GLfloat LightDiffuse[] =  { 0.7f, 0.7f, 0.7f, 0.7f};
	GLfloat LightSpecular[] = { 0.0f, 0.0f, 0.0f, 0.1f};
	GLfloat LightPosition[] = { 5.0f, 5.0f, 5.0f, 0.0f}; 

	GLfloat RedSurface[]   = { 1.0f, 0.0f, 0.0f, 1.0f};
	GLfloat GreenSurface[] = { 0.0f, 1.0f, 0.0f, 1.0f};
	GLfloat BlueSurface[]  = { 0.0f, 0.0f, 1.0f, 1.0f};

	//zorg dat het scherm wordt gewist en ook de diepte-buffer.
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	/*nu gaan we de attributen van het licht definieren.
	Zie cursus W.Simons over diffusie & andere zaken inzake
	zichtbare electromagnetische straling.
	Alsook de online help.
	We kunnen een i-aantal lichten definieren voor GL_LIGHTi.*/
	glLightfv(GL_LIGHT0, GL_AMBIENT, LightAmbient);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, LightDiffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, LightSpecular);
	glLightfv(GL_LIGHT0, GL_POSITION, LightPosition);
	//nu het licht aanzetten.
	glEnable(GL_LIGHT0);

	/* Een goede oefening zou zijn om geen lichtbron te gebruiken, 
	maar het materiaal zelf licht-gevend te maken.
	Dit door 'glMaterialfv' met de parameter GL_EMISSION te gebruiken
	en hiervoor waarden in te geven.
	Zo kunt u in een spelletje, gemakkelijk iets maken zoals neon-
	reclame dat aan de muur hangt.*/


	/*eenheidsmatrix op de stack zetten, omdat we voor elke nieuwe
	frame van nul willen beginnen. (op het einde van onze render, terug 'poppen')
	Doen we dit niet, dan zal elke nieuwe frame nog meer geroteerd
	worden dan de vorige frame. Maw. de rotatie en translatie wordt
	gecummuleerd.*/
	glPushMatrix();
		//model-matrix translated en rotated weergeven.
		glTranslated(0.0, -8.0, 0.0);
		//roteren over x-vector (=rond x-as)
		glRotated(rotx, 1.0, 0.0, 0.0);
		//roteren over z-vector (=rond z-as)
		glRotated(roty, 0.0, 0.0, 1.0);


		//Materiaal geeft de eigenschappen aan van het materiaal.
		//Hier dus een rood oppervlak en het licht dat erop valt
		//wordt gereflecteerd met AMBIENT en DIFFUSE eigenschappen.
		//(hiervoor gedefinieerd voor licht GL_LIGHT0 )
		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, RedSurface); 
		glBegin(GL_POLYGON);
			//door de normaalvector (lijn wijzend loodrecht op het
			//vlak) te definieren voor dit vlak, weet OpenGL over
			//welk vlak vd kubus het gaat.
			//Deze normaal wordt ook gebruikt voor belichting.
			//(lees ook online-help over "glLightModel" )
			//Voor elk vlak vd kubus, moet je in OpenGL 2 vlakken
			//definieren : FRONT en BACK.
			glNormal3d(  1.0,  0.0,  0.0);
			//nu punten van het vierkant in juiste volgorde opgeven.
			//indien je de volgorde niet begrijpt, stel ik voor om een paar
			//van plaats te verwisselen en het effect te zien. :)
			glVertex3d(  1.0,  1.0,  1.0);
			glVertex3d(  1.0, -1.0,  1.0);
			glVertex3d(  1.0, -1.0, -1.0);
			glVertex3d(  1.0,  1.0, -1.0);
		glEnd();

		glBegin(GL_POLYGON);
			glNormal3d( -1.0,  0.0,  0.0);
			glVertex3d( -1.0, -1.0,  1.0);
			glVertex3d( -1.0,  1.0,  1.0);
			glVertex3d( -1.0,  1.0, -1.0);
			glVertex3d( -1.0, -1.0, -1.0);
		glEnd();

		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, GreenSurface);
		glBegin(GL_POLYGON);
			glNormal3d(  0.0,  1.0,  0.0);
			glVertex3d(  1.0,  1.0,  1.0);
			glVertex3d( -1.0,  1.0,  1.0);
			glVertex3d( -1.0,  1.0, -1.0);
			glVertex3d(  1.0,  1.0, -1.0);
		glEnd();				  

		glBegin(GL_POLYGON);
			glNormal3d(  0.0, -1.0,  0.0);
			glVertex3d( -1.0, -1.0,  1.0);
			glVertex3d(  1.0, -1.0,  1.0);
			glVertex3d(  1.0, -1.0, -1.0);
			glVertex3d( -1.0, -1.0, -1.0);
		glEnd();

		glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, BlueSurface);
		glBegin(GL_POLYGON);
			glNormal3d(  0.0,  0.0,  1.0);
			glVertex3d(  1.0,  1.0,  1.0);
			glVertex3d( -1.0,  1.0,  1.0);
			glVertex3d( -1.0, -1.0,  1.0);
			glVertex3d(  1.0, -1.0,  1.0);
		glEnd();

		glBegin(GL_POLYGON);
			glNormal3d(  0.0,  0.0, -1.0);
			glVertex3d( -1.0,  1.0, -1.0);
			glVertex3d(  1.0,  1.0, -1.0);
			glVertex3d(  1.0, -1.0, -1.0);
			glVertex3d( -1.0, -1.0, -1.0);
		glEnd();
	glPopMatrix();

}
