// GLtutor4View.cpp : implementation of the CGLtutor4View class
//

#include "stdafx.h"
#include "GLtutor4.h"

#include "GLtutor4Doc.h"
#include "GLtutor4View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View

IMPLEMENT_DYNCREATE(CGLtutor4View, CView)

BEGIN_MESSAGE_MAP(CGLtutor4View, CView)
	//{{AFX_MSG_MAP(CGLtutor4View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View construction/destruction

CGLtutor4View::CGLtutor4View()
{
	// TODO: add construction code here
	my_GLRendContext = NULL;
	my_GLpixelindex=0;
	lbut = FALSE;
	RBdown=FALSE;
	depth=45.0;
	mpos=(320,240);
}

CGLtutor4View::~CGLtutor4View()
{
}

BOOL CGLtutor4View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View drawing

void CGLtutor4View::OnDraw(CDC* pDC)
{
	CGLtutor4Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View diagnostics

#ifdef _DEBUG
void CGLtutor4View::AssertValid() const
{
	CView::AssertValid();
}

void CGLtutor4View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGLtutor4Doc* CGLtutor4View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGLtutor4Doc)));
	return (CGLtutor4Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View message handlers

int CGLtutor4View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//Handle naar onze volledig window
	HWND hWnd = GetSafeHwnd();

	//handle naar de client-area (gebied waar getekend zal worden)
	HDC hDC = ::GetDC(hWnd);

	//zorg dat OpenGL output compatible is met ons windowke.
	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;

	//zorg dat de OpenGL uitvoer op ons windowke komt.
	if (CreateGLRenderContext(hDC)==FALSE)
		return 0;
	
	
	return 0;
}

void CGLtutor4View::OnDestroy() 
{
	// TODO: Add your message handler code here
	if(wglGetCurrentContext()!=NULL) 
	{
		// Zorg dat er geen verwijzing is tussen de OpenGL renderer en ons windowke.
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (my_GLRendContext!=NULL)
	{
		//verwijder onze OpenGL Rendering Context.
		wglDeleteContext(my_GLRendContext);
		my_GLRendContext = NULL;
	}

	//Nu kan de gewone window verwijderd worden.
	CView::OnDestroy();	
}

void CGLtutor4View::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CGLtutor4Doc* pDoc = GetDocument();
	pDoc->RenderScene();
	
	if (SwapBuffers(dc.m_ps.hdc)==FALSE)
	{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("SwapBuffers returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return;
	}

	// Do not call CView::OnPaint() for painting messages
}

void CGLtutor4View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	GLsizei width, height;
	GLdouble ratio;

	width = cx;
	height = cy;

	/* omdat we nu in 3D gaan werken, moeten we een juiste
	perspectief hebben op onze viewport (clientwindow).
	Soms kan het zijn dat de breedte van ons window groter is
	dan de hoogte en kan onze 3D modellen vervormen.
	Daarom bereken we even de verhouding breedte/hoogte om door
	te geven aan OpenGL zodat hij deze vervorming teniet kan doen als hij
	de objecten tekent.
	Zet dit gerust eens als commentaar en u zult zien dat
	onze kubus er raar uit gaat zien bij het vergroten/verkleinen
	van onze window.
	*/
	if (cy=0) ratio=(GLdouble)width;
	else ratio= (GLdouble)width / (GLdouble)height;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();

	/* Normaal kwam nu de gluOrtho2D-functie. Maar we gaan niet
	meer werken op een simpel 2D vlak, maar echte 3D. 
	Dus perspectief-aanpassing gebeurd met OpenGL-functie
	gluPerspective:
	 - 1ste parameter geeft de "field of view" aan in graden.
	   (dus hoe breed uw zicht op de 3D-wereld is.)
	   Hoe groter, hoe meer je kunt zien, maar hoe kleiner dus
	   de objecten zullen zijn op het scherm.
	   Dit brengt wel wat vervorming met zich mee als objecten 
	   niet in het centrum geroteerd worden (zie tutor5)
	   Indien je over het spel 'Quake2' beschikt, kun je de "console" eens openen 
	   (door op "" te drukken) en daarin "fov 120" intikken. Daarmee kunt u uw
	   "field of view" instellen. U zal direct zien wat de gevolgen daarvan zijn
	   en wat ik bedoelde met vervorming. (het visbokaal-effect)
	 - 2de parameter is onze ratio.
	 - 3de parameter geeft de near-clipping z-coordinaat weer.
	   dus als er een object wordt getekend op diepte kleiner dan
	   1, dan wordt dit object niet getekend.
	 - laatste parameter geeft de far-clipping z-coordinaat weer.
	   Indien er een object op een diepte groter dan 10 staat, wordt
	   dit niet op het scherm getekend. */
	gluPerspective(depth, ratio, 1.0, 10.0);
//	gluPerspective(depth, 1, 1.0, 10.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	//we gaan met double-buffering werken, dus we moeten in de backbuffer tekenen.
	glDrawBuffer(GL_BACK);

	/* als we onze kubus willen belichten met een lichtbron,
	moeten we dit aangeven. De lichtbron wordt elders gedefinieerd,
	hier zeggen we enkel dat we met belichten zullen werken.*/
	glEnable(GL_LIGHTING);

	/* Als het volgende niet enabled staat, dan worden alle vlakken van onze
	kubus getekend. Ook overlappende. Met DEPTH_TEST wordt eerst
	gesorteerd op diepte en enkel de voorste vlakken worden getekend.
	Dit zorgt voor minder overhead en een properder resultaat.
	Zet dit gerust uit en dan zult u zien dat onze kubus doorschijnen wordt.*/
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
}

BOOL CGLtutor4View::SetWindowPixelFormat(HDC myDC)
{
	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize		= sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion	= 1;
	pixelDesc.dwFlags	=	PFD_DRAW_TO_WINDOW | 
							PFD_DOUBLEBUFFER |
							PFD_GENERIC_ACCELERATED | 
							PFD_SUPPORT_OPENGL;

	pixelDesc.iPixelType		= PFD_TYPE_RGBA;
	pixelDesc.cColorBits		= 32;
	pixelDesc.cRedBits			= 8;
	pixelDesc.cRedShift			= 16;
	pixelDesc.cGreenBits		= 8;
	pixelDesc.cGreenShift		= 8;
	pixelDesc.cBlueBits			= 8;
	pixelDesc.cBlueShift		= 0;
	pixelDesc.cAlphaBits		= 0;
	pixelDesc.cAlphaShift		= 0;
	pixelDesc.cAccumBits		= 64;	
	pixelDesc.cAccumRedBits		= 16;
	pixelDesc.cAccumGreenBits	= 16;
	pixelDesc.cAccumBlueBits	= 16;
	pixelDesc.cAccumAlphaBits	= 0;
	pixelDesc.cDepthBits		= 32;
	pixelDesc.cStencilBits		= 8;
	pixelDesc.cAuxBuffers		= 0;
	pixelDesc.iLayerType		= PFD_MAIN_PLANE;
	pixelDesc.bReserved			= 0;
	pixelDesc.dwLayerMask		= 0;
	pixelDesc.dwVisibleMask		= 0;
	pixelDesc.dwDamageMask		= 0;

	my_GLpixelindex = ChoosePixelFormat(myDC, 
										&pixelDesc);
	if (my_GLpixelindex==0)
	{
		my_GLpixelindex = 1;	// Let's choose a default index.
		if (DescribePixelFormat( myDC, 
								 my_GLpixelindex, 
								 sizeof(PIXELFORMATDESCRIPTOR), 
								 &pixelDesc)==0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	myDC, 
						my_GLpixelindex, 
						&pixelDesc)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;

}

BOOL CGLtutor4View::CreateGLRenderContext(HDC myDC)
{
	my_GLRendContext = wglCreateContext(myDC); 

	if (my_GLRendContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	if (wglMakeCurrent(myDC, my_GLRendContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}

void CGLtutor4View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	lbut = TRUE;
	mpos = point;	
	CView::OnLButtonDown(nFlags, point);
}

void CGLtutor4View::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	lbut = FALSE;

	CView::OnLButtonUp(nFlags, point);
}

void CGLtutor4View::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (lbut)
	{
		CGLtutor4Doc* pDoc = GetDocument();
		CSize rotate = mpos - point;
		mpos = point;
		pDoc->roty -= rotate.cx/2;
		pDoc->rotx -= rotate.cy/2;
		//Zorg dat OnPaint (en dus onze RenderScene) wordt 
		//opgeroepen.
		InvalidateRect(NULL, FALSE);
	};

	if (RBdown)
	{
		CSize depthslide = mpos - point;
		mpos = point;
		depth -= depthslide.cy/2;
		if(depth < 5) depth=5;
		if(depth > 150) depth=150;

		//nu zorgen dat de viewport opnieuw wordt ingesteld
		RECT myrect;
		GetClientRect(&myrect);
		OnSize(SIZE_RESTORED, myrect.right-myrect.left, myrect.bottom-myrect.top);
		//kubus opnieuw tekenen (via OnPaint RenderScene() oproepen. )
		InvalidateRect(NULL, FALSE);
	}
	CView::OnMouseMove(nFlags, point);
}

void CGLtutor4View::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	RBdown=TRUE;
	mpos=point;
	CView::OnRButtonDown(nFlags, point);
}

void CGLtutor4View::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	RBdown=FALSE;
	CView::OnRButtonUp(nFlags, point);
}
