// GLtutor4View.cpp : implementation of the CGLtutor4View class
//

#include "stdafx.h"
#include "GLtutor4.h"

#include "GLtutor4Doc.h"
#include "GLtutor4View.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View

IMPLEMENT_DYNCREATE(CGLtutor4View, CView)

BEGIN_MESSAGE_MAP(CGLtutor4View, CView)
	//{{AFX_MSG_MAP(CGLtutor4View)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_WM_PAINT()
	ON_WM_SIZE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_RBUTTONDOWN()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View construction/destruction

CGLtutor4View::CGLtutor4View()
{
	// TODO: add construction code here
	my_GLRendContext = NULL;
	my_GLpixelindex=0;
	lbut = FALSE;
	RBdown=FALSE;
	depth=45.0;
}

CGLtutor4View::~CGLtutor4View()
{
}

BOOL CGLtutor4View::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View drawing

void CGLtutor4View::OnDraw(CDC* pDC)
{
	CGLtutor4Doc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View diagnostics

#ifdef _DEBUG
void CGLtutor4View::AssertValid() const
{
	CView::AssertValid();
}

void CGLtutor4View::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CGLtutor4Doc* CGLtutor4View::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CGLtutor4Doc)));
	return (CGLtutor4Doc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CGLtutor4View message handlers

int CGLtutor4View::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	// TODO: Add your specialized creation code here
	//Handle naar onze volledig window
	HWND hWnd = GetSafeHwnd();

	//handle naar de client-area (gebied waar getekend zal worden)
	HDC hDC = ::GetDC(hWnd);

	//zorg dat OpenGL output compatible is met ons windowke.
	if (SetWindowPixelFormat(hDC)==FALSE)
		return 0;

	//zorg dat de OpenGL uitvoer op ons windowke komt.
	if (CreateGLRenderContext(hDC)==FALSE)
		return 0;

	//load in texturefiles
	CGLtutor4Doc* pdoc = GetDocument();
	FILE *myfile;

	//eerste texture
	myfile = fopen("EARTH.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		CString notice;
		notice.Format("Loaded texture image 1 correctly");
		AfxMessageBox(notice);
		int size = fread(pdoc->texImage,1,256*256*3,myfile);
		fclose(myfile);
		};

	//tweede texture
	myfile = fopen("APPLE.RAW","rb");
	if(myfile == NULL) {
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("I could not load the texture2 image ! Code %d.", errorCode);
		AfxMessageBox(errorStr);
		}
	else {
		CString notice;
		notice.Format("Loaded texture image 2 correctly");
		AfxMessageBox(notice);
		int size = fread(pdoc->texImage2,1,256*256*3,myfile);
		fclose(myfile);
		};

	//OGL texture-list aanmaken. Array is myText, en we gaan 2
	//texture gebruiken. (myText is een public array van GLubyte in
	//de Doc-class.)
	glGenTextures(2,pdoc->myText);

	//parameters instellen voor eerste texture;
	//parameters worden gekoppeld(bind)aan onze eerste texture
	//(earth)
	glBindTexture(GL_TEXTURE_2D, pdoc->myText[0]);   		
	//Nu stellen we in hoe de texture op het object geplakt moet
	//worden. GL_CLAMP wordt het uitgerokken zodat het het hele
	//object beslaat. GL_REPEAT wordt het herhaald weergegeven.
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	//Nu stellen we in welke filter-procedure OGL moet gebruiken :
	//GL_NEAREST wordt een zr eenvoudig filtering gebruikt.
	//Deze werkt snel, maar bij inzoomen zien we dat de pixels
	//echte blokken worden en dit is niet zo mooi.
	//GL_LINEAR is de bi-linear filtering methode. Deze doet een
	//interpolatie van de punten wat een mooi vloeiend effect maakt.
	//Bij inzoomen kan het wat 'blurry' overkomen.
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	//Ten laatste moeten we aangeven waar OGL de eigenlijjke texture
	//moet halen in het geheugen. En hoe groot de texture is en
	//welk formaat dit is.
	//Dit was voor mij een zeer grote frustratie geweest, omdat ik
	//eerst met bitmaps werkte. De pointer naar de pixels, gebruikte
	//ik dan de .bmBits member-variabele van de bitmap.
	//Nu bleek dat OGL pure RGB of RGBA waarden mooi netjes na elkaar
	//wilt. Dus ik heb de bitmap in Paint Shop Pro 6 geladen en
	//gesaved als een "raw" image file. (hiermee bewaart hij enkel en
	//alleen de RGB waarden van de pixels in een bestand, en geen
	//info over kleurdiepte, hoogte, breedt of iets anders.)
	//Als je die RAW terug inlaadt, vraag PSP om hoogte en breedt en
	//het formaat (RGB, BGR, RGBA, ABGR). Vul iets verkeerds in en
	//PSP geeft een volledige verstoorde tekening weer. (logisch)
	//Daarom moet je in de volgende opdracht ook de hoogte en breedte
	//meegeven (ALTIJD een exp van 2. Hier 256. OGL ondersteunt
	//textures van 2048 op 2048, wat momenteel enkel nog maar de
	//Nvidea TNT2 (hardwarematig) ondersteund. QuakeIII maakt van 
	//deze gigantische textures gebruik, wat een zeer realistische
	//wereld weergeeft.
	//ps: 2de parameter geeft de hoeveelste mipmap aan. (0=oorspronkelijke tekening)
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->texImage);

	//idem voor 2de texture
	glBindTexture(GL_TEXTURE_2D, pdoc->myText[1]);   		
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);	
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexImage2D(GL_TEXTURE_2D,0,3,256,256,0,GL_RGB,GL_UNSIGNED_BYTE,pdoc->texImage2);
	
	//Nu geven we aan in welke mode we werken. GL_DECAL plakt de
	//texturen gewoon op de objecten en GL_MODULATE moduleert de texture
	//waardoor doorschijnende effecten kunnen bekomen worden. (zoals 
	//een raam of bvb een raam ve kerk). Moet hier gebruikt worden als
	//je het lichtinval-effect erbij wilt hebben. GL_BLEND werkt vooral met 
	//de alpha-componenten van de texture (alleen als je texture
	//van het formaat RGBA is). Dit kan een knappe schaduw genereren.
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_DECAL);
	
	return 0;
}

void CGLtutor4View::OnDestroy() 
{
	// TODO: Add your message handler code here
	if(wglGetCurrentContext()!=NULL) 
	{
		// Zorg dat er geen verwijzing is tussen de OpenGL renderer en ons windowke.
		wglMakeCurrent(NULL, NULL) ;
	}
	
	if (my_GLRendContext!=NULL)
	{
		//verwijder onze OpenGL Rendering Context.
		wglDeleteContext(my_GLRendContext);
		my_GLRendContext = NULL;
	}
	
	CGLtutor4Doc* pdoc = GetDocument();
	glDeleteTextures(2,pdoc->myText);

	//Nu kan de gewone window verwijderd worden.
	CView::OnDestroy();	
}

void CGLtutor4View::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	CGLtutor4Doc* pDoc = GetDocument();
	pDoc->RenderScene();
	
	if (SwapBuffers(dc.m_ps.hdc)==FALSE)
	{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("SwapBuffers returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return;
	}

	// Do not call CView::OnPaint() for painting messages
}

void CGLtutor4View::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	
	// TODO: Add your message handler code here
	GLsizei width, height;
	GLdouble ratio;

	width = cx;
	height = cy;
	if (cy=0) ratio=(GLdouble)width;
	else ratio= (GLdouble)width / (GLdouble)height;

	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(depth, ratio, 1.0, 100.0);
//	gluPerspective(depth, 1, 1.0, 10.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glDrawBuffer(GL_BACK);
	glEnable(GL_LIGHTING);
	glShadeModel(GL_SMOOTH);
	glEnable(GL_DEPTH_TEST);
	glEnable( GL_TEXTURE_2D );

}

BOOL CGLtutor4View::SetWindowPixelFormat(HDC myDC)
{
	PIXELFORMATDESCRIPTOR pixelDesc;

	pixelDesc.nSize		= sizeof(PIXELFORMATDESCRIPTOR);
	pixelDesc.nVersion	= 1;
	pixelDesc.dwFlags	=	PFD_DRAW_TO_WINDOW | 
							PFD_DOUBLEBUFFER |
							PFD_GENERIC_ACCELERATED | 
							PFD_SUPPORT_OPENGL;

	pixelDesc.iPixelType		= PFD_TYPE_RGBA;
	pixelDesc.cColorBits		= 32;
	pixelDesc.cRedBits			= 8;
	pixelDesc.cRedShift			= 16;
	pixelDesc.cGreenBits		= 8;
	pixelDesc.cGreenShift		= 8;
	pixelDesc.cBlueBits			= 8;
	pixelDesc.cBlueShift		= 0;
	pixelDesc.cAlphaBits		= 0;
	pixelDesc.cAlphaShift		= 0;
	pixelDesc.cAccumBits		= 64;	
	pixelDesc.cAccumRedBits		= 16;
	pixelDesc.cAccumGreenBits	= 16;
	pixelDesc.cAccumBlueBits	= 16;
	pixelDesc.cAccumAlphaBits	= 0;
	pixelDesc.cDepthBits		= 32;
	pixelDesc.cStencilBits		= 8;
	pixelDesc.cAuxBuffers		= 0;
	pixelDesc.iLayerType		= PFD_MAIN_PLANE;
	pixelDesc.bReserved			= 0;
	pixelDesc.dwLayerMask		= 0;
	pixelDesc.dwVisibleMask		= 0;
	pixelDesc.dwDamageMask		= 0;

	my_GLpixelindex = ChoosePixelFormat(myDC, 
										&pixelDesc);
	if (my_GLpixelindex==0)
	{
		my_GLpixelindex = 1;	// Let's choose a default index.
		if (DescribePixelFormat( myDC, 
								 my_GLpixelindex, 
								 sizeof(PIXELFORMATDESCRIPTOR), 
								 &pixelDesc)==0)
		{
			DWORD errorCode = GetLastError();
			CString errorStr;
			errorStr.Format("DescribePixelFormat returned error code %d.", errorCode);
			AfxMessageBox(errorStr);
			return FALSE;
		}
	}

	if (SetPixelFormat(	myDC, 
						my_GLpixelindex, 
						&pixelDesc)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("SetPixelFormat returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;

}

BOOL CGLtutor4View::CreateGLRenderContext(HDC myDC)
{
	my_GLRendContext = wglCreateContext(myDC); 

	if (my_GLRendContext == NULL)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	if (wglMakeCurrent(myDC, my_GLRendContext)==FALSE)
	{
		DWORD errorCode = GetLastError();
		CString errorStr;
		errorStr.Format("wglCreateContext returned error code %d.", errorCode);
		AfxMessageBox(errorStr);
		return FALSE;
	}

	return TRUE;
}

void CGLtutor4View::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	lbut = TRUE;
	mpos = point;	
	CView::OnLButtonDown(nFlags, point);
}

void CGLtutor4View::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	lbut = FALSE;

	CView::OnLButtonUp(nFlags, point);
}

void CGLtutor4View::OnMouseMove(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	if (lbut)
	{
		CGLtutor4Doc* pDoc = GetDocument();
		CSize rotate = mpos - point;
		mpos = point;
		pDoc->roty -= rotate.cx/2;
		pDoc->rotx -= rotate.cy/2;
		//Zorg dat OnPaint (en dus onze RenderScene) wordt 
		//opgeroepen.
		InvalidateRect(NULL, FALSE);
	};

	if (RBdown)
	{
		CSize depthslide = mpos - point;
		mpos = point;
		depth -= depthslide.cy/2;
		if(depth < 5) depth=5;
		if(depth > 150) depth=150;

		//nu zorgen dat de viewport opnieuw wordt ingesteld
		RECT myrect;
		GetClientRect(&myrect);
		OnSize(SIZE_RESTORED, myrect.right-myrect.left, myrect.bottom-myrect.top);
		//kubus opnieuw tekenen (via OnPaint RenderScene() oproepen. )
		InvalidateRect(NULL, FALSE);
	}
	CView::OnMouseMove(nFlags, point);
}

void CGLtutor4View::OnRButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	RBdown=TRUE;
	mpos=point;
	CView::OnRButtonDown(nFlags, point);
}

void CGLtutor4View::OnRButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	RBdown=FALSE;
	CView::OnRButtonUp(nFlags, point);
}
